function val = LoopTerm(edgeStruct,nodeBelLBP, edgeBelLBP, beta, X)
% calculate Loop Series value
if isequal(X,zeros(size(X)))
    val = 1;
else
    newEdgeEnds = edgeStruct.edgeEnds(X == 1, :);
    newadj = zeros(edgeStruct.nNodes);
    for i = 1: size(newEdgeEnds, 1)
        newadj(newEdgeEnds(i,1), newEdgeEnds(i,2)) = 1;
        newadj(newEdgeEnds(i,2), newEdgeEnds(i,1)) = 1;
    end
    newDegree = sum(newadj, 2);
    val = 1;
    for e = 1:edgeStruct.nEdges
        if X(e,1) == 1
            tau_u = nodeBelLBP(edgeStruct.edgeEnds(e,1),2);
            tau_v = nodeBelLBP(edgeStruct.edgeEnds(e,2),2);
            top = (edgeBelLBP(2,2,e) - (tau_u*tau_v ));
            bot = (tau_u * (1-tau_u) *tau_v *(1-tau_v));
            top/bot;
            val = val * top / bot;
        end
    end
    for n = 1:edgeStruct.nNodes
        d = newDegree(n,1);
        tau = nodeBelLBP(n,2);
        if d ~= 1
            tmp = tau * (1-tau) * (tau^(d-1)+ (-1)^d * (1-tau)^(d-1));
            val = val * tmp;
        else
            val = 0;
        end
    end
    if abs(val) > 1e8
        val = 0;
    end
end
val = val^beta;
end